module InstructionMemoryCoregen(
    Clock,
    Enable,

    FetchAddress,
    FetchOut,
    FetchEnable,

    DataAddress,
    DataIn,
    DataInEnable,
    DataOut,
    DataOutEnable
);

// NOTE: These are now meaninglses
parameter DataWidth = 32,
          AddressWidth = 12,
          InitialHexFile = "";

input                           Clock;
input                           Enable;

input       [15:0]              FetchAddress;
output      [31:0]              FetchOut;
input                           FetchEnable;

input       [15:0]              DataAddress;
input       [31:0]              DataIn;
input                           DataInEnable;
output      [31:0]              DataOut;
input                           DataOutEnable;

blk_mem_gen_v3_3 imem0(
    .ena(                       Enable),
    .enb(                       FetchEnable),
    .clka(                      Clock),
    .clkb(                      Clock),
    .wea(                       DataInEnable),
    .addra(                     DataAddress[15:2]),
    .addrb(                     FetchAddress[15:2]),
    .doutb(                     FetchOut),
    .dina(                      DataIn)
);

blk_mem_gen_v3_3 imem1(
    .ena(                       Enable),
    .enb(                       DataOutEnable),
    .clka(                      Clock),
    .clkb(                      Clock),
    .wea(                       DataInEnable),
    .addra(                     DataAddress[15:2]),
    .addrb(                     DataAddress[15:2]),
    .doutb(                     DataOut),
    .dina(                      DataIn)
);

endmodule
