module SourceOfClocks (
    Clock100MHz,
    Clock125MHz,
    Clock50MHz
);

input                           Clock100MHz;
output                          Clock125MHz;
output                          Clock50MHz;


wire                            clkinibufg;
wire                            clkfx;
wire                            clk0;
wire                            clkfbin;


IBUFG clkinibuf(
    .I(                         Clock100MHz), 
    .O(                         clkinibufg)
); 

BUFG clkfxbuf(
    .I(                         clkfx), 
    .O(                         Clock125MHz)
);

BUFG clkdvbuf(
    .I(                         clkdv), 
    .O(                         Clock50MHz)
);

BUFG clk0buf(
    .I(                         clk0), 
    .O(                         clkfbin)
);

DCM_ADV #(
    .CLK_FEEDBACK(              "1X"),
    .CLKDV_DIVIDE(              2.0),
    .CLKFX_DIVIDE(              5),
    .CLKFX_MULTIPLY(            5),
    .CLKIN_DIVIDE_BY_2(         "FALSE"),
    .CLKIN_PERIOD(              10.0),
    .CLKOUT_PHASE_SHIFT(        "NONE"),
    .DCM_AUTOCALIBRATION(       "TRUE"),
    .DCM_PERFORMANCE_MODE(      "MAX_SPEED"),
    .DESKEW_ADJUST(             "SYSTEM_SYNCHRONOUS"),
    .DFS_FREQUENCY_MODE(        "LOW"),
    .DLL_FREQUENCY_MODE(        "LOW"),
    .DUTY_CYCLE_CORRECTION(     "TRUE"),
    .FACTORY_JF(                16'hF0F0),
    .PHASE_SHIFT(               0),
    .STARTUP_WAIT(              "TRUE"),
    .SIM_DEVICE(                "VIRTEX5")
) dcm125mhz(
    .CLKFB(                     clkfbin),
    .CLKIN(                     clkinibufg),
    .DADDR(                     7'b0000000),
    .DCLK(                      1'b0),
    .DEN(                       1'b0),
    .DI(                        16'h0000),
    .DWE(                       1'b0),
    .PSCLK(                     1'b0),
    .PSEN(                      1'b0),
    .PSINCDEC(                  1'b0),
    .RST(                       1'b0),
    .CLKDV(                     clkdv),
    .CLKFX(                     clkfx),
    .CLKFX180(                  ),
    .CLK0(                      clk0),
    .CLK2X(                     ),
    .CLK2X180(                  ),
    .CLK90(                     ),
    .CLK180(                    ),
    .CLK270(                    ),
    .DO(                        ),
    .DRDY(                      ),
    .LOCKED(                    ),
    .PSDONE(                    )
);

endmodule
